/*
  step_motor6.cpp
  Cree par Silicium628, 09 nov 2014
  version 3.1
  code free Open source
*/

#include "Arduino.h"
#include "step_motor6.h"


#define _nop_() do { __asm__ volatile ("mov r0, r0"); } while (0)

Step_Motor::Step_Motor()
{
	
}

void Step_Motor::init()
{
	marche=0;
	sens=0;
	disable();
	steps_par_mm = steps_par_tour * tours_par_mm; 
	impuls_par_mm = steps_par_mm * impuls_par_step;
}


void  Step_Motor::set_marche(uint8_t valeur)
{ 
	marche = valeur;
}


uint8_t Step_Motor::get_marche()
{
	return marche;
}


void  Step_Motor::enable()
{ 
	PORT_moteur_enable &= ~bit_ENABLE; 
}


void  Step_Motor::disable()
{ 
	PORT_moteur_enable |= bit_ENABLE;
}


void  Step_Motor::RAZ_pos()
{ 
	position_impuls=0;
	compteur_impuls=0;
}


void Step_Motor::RAZ_compteur_impuls()
{
	compteur_impuls =0;
}


long Step_Motor::get_compteur_impuls()
{
	return compteur_impuls;
}


void  Step_Motor::step()
{
	if ( ((sens == 1) && (stop_sens1 == 0) ) || ((sens == 0) && (stop_sens2 == 0) ) )
	{
		PORT_step |= bit_STEP;  // RA1
		if (sens == 0) { position_impuls += 1; } else { position_impuls -= 1; } 
		compteur_impuls++;
		PORT_led_blanche ^= bit_LED_blanche; // cette ligne sert surtout de tempo pour la largeur d'impulsion
		PORT_step &= ~bit_STEP; // RAZ
	}
}


void  Step_Motor::set_sens(uint8_t valeur)
{ 
	sens = valeur;
	if(sens == 0) {PORT_dir |= bit_DIR; } else {PORT_dir &= ~bit_DIR;}
}


void  Step_Motor::set_stop_sens1(uint8_t valeur)
{ 
	stop_sens1 = valeur;
}


void  Step_Motor::set_stop_sens2(uint8_t valeur)
{ 
	stop_sens2 = valeur;
}


uint8_t Step_Motor::get_sens()
{
	return sens;
}
